using System;
using System.Collections;
using System.Diagnostics;
using Nwc.XmlRpc;
class Client {
  public static String NL = "\n\r";
  public static void Main(String[] args) {

    String url = "http://www.scs.ubbcluj.ro:7777/";
    String user = "NUME_USER";
    String password = "PAROLA";
    String host1 = "cs.ubbcluj.ro";
    String host2 = "scs.ubbcluj.ro";
    String filtru1 = "{host=scs.ubbcluj.ro}"; // Toti userii de pe hostul specificat
    String filtru2 = "{nume=Co.*|Mi.*,host=scs.ubbcluj.ro,grupa=gr231|gr252}";
    String filtru3 = "{user=florin,host=cs.ubbcluj.ro}"; // Numai userul florin de pe hostul specificat
    String subject1 = "Luni, 30.11.2009 liber";
    String subject2 = "Subiect test";
    String mesaj1 = "Mesaj de\ntest cu pachetul XmlRpc.dll";
    String mesaj2 = "1. Luni, 30.11.2009 este zi libera. Studentii, de comun acord" +
            " cu profesorii, vor stabili recuperarile necesare.\n" +
            "2. Studentii din anul 2, ca si masteranzii din anul 1, sunt invitati " +
            "sa isi aleaga lucrarile de licenta / disertatie\n" +
            "Dupa cum s-a mai anuntat, celor care nu isi aleg li se vor repartiza " +
            "din oficiu";
    Object[] parametrii;
    XmlRpcResponse raspuns;

    // Eventuala preluare a unui URL al serviciului
    foreach (String s in args) {
      if (s.ToUpper().IndexOf("URL=") == 0) url = s.Substring(4);
    }
    if (url[url.Length - 1] != '/') {
      url += "/";
    }

    XmlRpcRequest client = new XmlRpcRequest();

    // Urmeaza apelurile de test
    Console.WriteLine("Client C# (cateva teste de apel):");

    parametrii = new Object[]{user, password, host1};
    setClientParams(client, "UsersGateway.authenticateUser", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host2};
    setClientParams(client, "UsersGateway.authenticateUser", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host1};
    setClientParams(client, "UsersGateway.getAllAni", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host2};
    setClientParams(client, "UsersGateway.getAllCatedre", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host2};
    setClientParams(client, "UsersGateway.getAllGrupe", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host2};
    setClientParams(client, "UsersGateway.getAllSpecializari", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host2};
    setClientParams(client, "UsersGateway.getAllUseri", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host1, filtru2};
    setClientParams(client, "UsersGateway.getUsers", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host2, filtru3};
    setClientParams(client, "UsersGateway.getUsers", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host1, filtru3, subject1, mesaj1};
    setClientParams(client, "UsersGateway.sendMail", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);

    parametrii = new Object[]{user, password, host1, filtru1,  subject2, mesaj2};
    setClientParams(client, "UsersGateway.sendMail", parametrii);
    raspuns = client.Send(url);
    Console.WriteLine(NL+raspuns.Value);
  }
  
  private static void setClientParams(XmlRpcRequest client, String metoda, Object[] parametrii) {
    client.MethodName = metoda;
    client.Params.Clear();
    foreach (Object param in parametrii) {
      client.Params.Add(param);
    }
  }
}
